//================================================================================================
// This is the superclass of all thnigs flyable, made by WCCC, help from Anna, AKA Wild or WildCat
// Additional help from all those guys who supported me back at fgs clan forum
//================================================================================================
class MSFlyables extends MSDrivables;

var() bool HasBombs;
var() int MaxBombs;
var() float BombTime, BombTimer;
var int BombsLeft;
var() class<Projectile> BombType;
var MenuUIFlyingWindow _FlyingScreen; //our current driving screen
var float StallTimer; //used for disabling flight
var class<MenuUIFlyingWindow> FlyingScreenType; //used for custom window types
var class<MenuUIFlyingWindow> MPFlyingScreenType; //used for custom window types in mp
var() rotator BombRotation;
var rotator DriverRotation;
var int ViewPointNum;
var bool bCrashed; //used to tell if its already plopped out of the sky

replication
{
     reliable if (Role == ROLE_Authority)
         BombTime, MaxBombs, HasBombs, BombsLeft, StallTimer, bCrashed, BombType, ViewPointNum, DriverRotation;
     reliable if (Role < ROLE_Authority)
         BombTimer, BlowTheLoad, MSFlyUpward, MSFlyDownward, SwitchViewPos;
}

simulated function PostBeginPlay()
{
 Super.PostBeginPlay();

 if (Level.NetMode != NM_Standalone)
 {
  FlyingScreenType = MPFlyingScreenType;
  AmbientSound = None;
 }
 BombsLeft = MaxBombs; //start off with a full load o' bombs
}

simulated function EjectPassenger()
{
 if (MSCarPassenger != None)
 {
    MSCarPassenger.SetLocation(Location + (PassengerDump >> Rotation)); 
    MSCarPassenger = None;
   if (IsInState('MSDriving2'))
    GoToState('MSDriving1');
 }
}

simulated function StopMSDriving()
{
    MSCarDriver.SetLocation(Location + (DriverDump >> Rotation)); 
    MSCarDriver.StartWalk();
//    MSCarDriver.ViewTarget = None;
//    MSCarDriver.bBehindView = False;
    MSCarDriver = None;
    SetOwner(None);
    /*if (MSCarPassenger != None)
    {
     MSCarPassenger.SetLocation(Location + (PassengerDump >> Rotation)); 
     MSCarPassenger = None;
    }*/
//    bBlockActors = True;
//    bBlockPlayers = True;
    //_FlyingScreen.root.PopWindow();
    if (Level.NetMode == NM_Standalone)
     _flyingScreen = None;
   if (!IsInState('Exploding'))
   {
    SetPhysics(PHYS_Falling); //added because the car floats in the air otherwise...
    GoToState('Active');
   }
    return;  
}

simulated function HandleWaterDriving()
{
 //obsolete
}

simulated function HandleDyingDriver()
{
    if ((MSCarDriver != None) && (MSCarDriver.IsInState('Dying'))) //you cant drive if you're dead!
    {
     MaxBombs = Default.MaxBombs;
     MSCarDriver = None;
     /*if (MSCarPassenger != None)
     {
      MSCarPassenger.SetLocation(Location + (PassengerDump >> Rotation)); 
      MSCarPassenger = None;
     }*/ 
     bBlockActors = True;
     bBlockPlayers = True;
    if (Level.NetMode == NM_Standalone)
     _FlyingScreen = None;
     SetPhysics(PHYS_Falling); //added because the car floats in the air otherwise...
    GoToState('Active');
    }
}

simulated function HandleLivingDriver()
{
 //:P
}

simulated function HandlePassenger()
{
    if (MSCarPassenger != None)
    {
     if (MSCarPassenger.IsInState('Dying'))
      MSCarPassenger = None;
     else
     {
      UpdatePassengerPos();
     }
    }
}

simulated function SwitchViewPos()
{
 //more secrets XD
}

state MSDriving1
{
function Tick(float DeltaTime)
{
 w/out passenger
}
}

state MSDriving2
{
function Tick(float DeltaTime)
{
 w/ passenger
}
}

simulated function string GetDrivingStats() //to be overridden in custom classes such as helicopters and whatnot 
{
 local string StatsMessage;
 
 StatsMessage = "Current Speed:"$MSCarSpeed * 360000 /16 /5280$" MPH, Gas Left: "$GasLeft / 50000$",|n Stats _/10: 1.Speed:"$CarSpeed$",2.Accel:"$MSAccelerationSpeed$",3.Gas:"$TopGas$",|n4.Strength:"$BrakeStrength$", Weapon: "$LeftGun.GunName$", |nAmmoLeft: "$(LeftGun.AmmoLeft + RightGun.AmmoLeft) / LeftGun.NumberOfShots$", Elevation:"$Location.Z - GarageLocation.Z$"|n Bombs Left:"$BombsLeft$", Gun Rotation:"$(LeftGun.Rotation.Pitch - LeftGun.AttachmentRotation.Pitch) / 92.555555$"";
 
 return StatsMessage;
}

simulated function MSFlyUpward()
{
}

simulated function MSFlyDownward()
{
}

//Warning, the following function is part cockjoke...

simulated function BlowTheLoad()
{
  local DeusExProjectile proj;

   if ((Location.Z > GarageLocation.Z) && (BombTimer <= 0) && (BombsLeft > 0) && (HasBombs))
   {
    proj = DeusExProjectile(Spawn(BombType, MSCarDriver,, Location - (vect(0,0,1) * (CollisionHeight + 34)), Rotation + BombRotation));
    BombTimer = BombTime;
    BombsLeft -= 1;
   }
}

defaultproperties
{
     HasBombs=True
     BombType=Class'DeusEx.RocketLaw'
     MaxBombs=10
     bExplosive=True
     bOwnerNoSee=True
     explosionRadius=750
     explosionDamage=175
     BombRotation=(Pitch=-16660,Yaw=0,Roll=0)
     FlyingScreenType=Class'MSDriving1_2.MenuUIFlyingWindow'
     MPFlyingScreenType=Class'MSDriving1_2.MPMenuUIFlyingWindow'
     VehicleRespawnTime=30.000000
     BombTime=2.500000
     MPFiringSound=Sound'MSDriving1_2.Weapons.AK47Fire'
     ShotTime=0.100000
     MPProjectileClass=Class'MSDriving1_2.RedBullet'
     KnownGuns(0)=Class'MSDriving1_2.DrivableWeaponAssaultGun'
     KnownGuns(1)=Class'MSDriving1_2.DrivableWeaponAssaultGun'
     KnownGuns(2)=Class'MSDriving1_2.DrivableWeaponAssaultGun'
     KnownGuns(3)=Class'MSDriving1_2.DrivableWeaponAssaultGun'
}
